﻿@* DXCOMMENT: Configure GridView *@
@using DevExpress.Web.Mvc;
@using DevExpress.Web.Mvc.UI;
@using System.Web.UI.WebControls;

@Html.DevExpress().GridView(
    settings =>
    {
        settings.Name = "Gv_PickingListInquiry";
        settings.KeyFieldName = "PICKING_LIST_NO; CHANGED_BY; CHANGED_DT";
        settings.CallbackRouteValues = new { Controller = "PickingListInquiry", Action = "PickingListInquiryCallBack" };
        settings.Width = System.Web.UI.WebControls.Unit.Percentage(100);
        settings.ControlStyle.Paddings.Padding = System.Web.UI.WebControls.Unit.Pixel(0);
        settings.ControlStyle.Border.BorderWidth = System.Web.UI.WebControls.Unit.Pixel(0);
        settings.ControlStyle.BorderBottom.BorderWidth = System.Web.UI.WebControls.Unit.Pixel(1);
        
         //DIGUNAKAN UNTUK PEMANGGILAN SEARCH DATA
        settings.ClientSideEvents.BeginCallback = "onBeginCallbackPickingListInquiry";    
        settings.ClientSideEvents.EndCallback = "OnEndCallback";        
                
        settings.CommandColumn.Visible = true;
        settings.CommandColumn.Width = System.Web.UI.WebControls.Unit.Pixel(30);
        settings.CommandColumn.ShowSelectCheckbox = true;
        settings.ClientSideEvents.SelectionChanged = "Gv_PickingListInquiry_SelectionChanged";
        
        settings.SettingsEditing.Mode = GridViewEditingMode.Inline;      
        
        settings.SettingsPager.Visible = true;
        settings.Settings.ShowFilterRowMenu = false;
        settings.Settings.ShowFilterRow = false;
        
        settings.SettingsPager.FirstPageButton.Visible = true;
        settings.SettingsPager.LastPageButton.Visible = true;
        settings.SettingsPager.ShowNumericButtons = true;
        settings.SettingsPager.Position = System.Web.UI.WebControls.PagerPosition.Bottom;
        settings.SettingsPager.PageSizeItemSettings.Visible = true;
        settings.SettingsPager.PageSizeItemSettings.Items = new string[] { "15", "30", "50", "100" };
        settings.SettingsPager.PageSize = 15;
        settings.SettingsPager.PageSizeItemSettings.Caption = "View per page";
                
        settings.Settings.VerticalScrollBarMode = ScrollBarMode.Auto;
        settings.Settings.HorizontalScrollBarMode = ScrollBarMode.Auto;
        settings.Settings.VerticalScrollableHeight = 400;        
        
         // DXCOMMENT: Configure grid's columns in accordance with data model fields         
        settings.Width = 1330;
//        settings.CommandColumn.FixedStyle = GridViewColumnFixedStyle.Left;
        settings.CommandColumn.SetHeaderTemplateContent(c =>
        {
            if (c.Column.VisibleIndex == 0)
            {
                Html.DevExpress().CheckBox(
                    chckBox =>
                    {
                        chckBox.Name = "chckBox";
                        chckBox.Properties.ClientSideEvents.CheckedChanged = "function(s, e){ Gv_PickingListInquiry.SelectAllRowsOnPage(chckBox.GetChecked());}";
                    }
                ).Render();
            }
            
        });



    settings.Columns.Add(
    column =>
    {
        column.FieldName = "PICKING_LIST_NO";
        column.Name = "PICKING_LIST_NO";
        column.Caption = "Picking List No";
        column.CellStyle.Wrap = DefaultBoolean.True;
        column.ColumnType = MVCxGridViewColumnType.TextBox;
        column.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        column.CellStyle.VerticalAlign = System.Web.UI.WebControls.VerticalAlign.Middle;
        column.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        column.Width = Unit.Pixel(115);
        column.SetDataItemTemplateContent(container =>
        {
                    Html.DevExpress().HyperLink(hlSettings =>
                    {
                        hlSettings.Name = string.Format("hl_{0}", (container as GridViewDataItemTemplateContainer).VisibleIndex);
                        hlSettings.ControlStyle.Font.Underline = true;
                        hlSettings.NavigateUrl = "javascript:void(0)"; 
                        hlSettings.Properties.ClientSideEvents.Click = string.Format("function(s, e) {{ OnHyperLinkClick('{0}','{1}','{2}','{3}');}}",

                            Convert.ToString(DataBinder.Eval(container.DataItem, "PICKING_LIST_NO")),
                            Convert.ToString(DataBinder.Eval(container.DataItem, "PICKING_LIST_DATE")),
                            Convert.ToString(DataBinder.Eval(container.DataItem, "PICKING_LIST_TIME")),
                            Convert.ToString(DataBinder.Eval(container.DataItem, "ZONE"))
                      );
                        hlSettings.Properties.Text = (container as GridViewDataItemTemplateContainer).Text;
                    }).Render();
                });

        //TextBoxProperties propertiestextBox = column.PropertiesEdit as TextBoxProperties;

    });

    settings.Columns.Add(
    column =>
    {
        column.FieldName = "ZONE";
        column.Name = "ZONE";
        column.Caption = "Zone";
        column.CellStyle.Wrap = DefaultBoolean.True;
        column.ColumnType = MVCxGridViewColumnType.TextBox;
        column.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        column.CellStyle.VerticalAlign = System.Web.UI.WebControls.VerticalAlign.Middle;
        column.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        column.Width = Unit.Pixel(200);

    });


    settings.Columns.Add(
    column =>
    {
        column.FieldName = "PICKING_LIST_DATE";
        column.Name = "PICKING_LIST_DATE";
        column.Caption = "Picking List Date";
        column.CellStyle.Wrap = DefaultBoolean.True;
        column.ColumnType = MVCxGridViewColumnType.TextBox;
        column.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        column.CellStyle.VerticalAlign = System.Web.UI.WebControls.VerticalAlign.Middle;
        column.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        column.Width = Unit.Pixel(190);

    });


    settings.Columns.Add(
    column =>
    {
        column.FieldName = "PICKING_LIST_TIME";
        column.Name = "PICKING_LIST_TIME";
        column.Caption = "Picking List Time";
        column.CellStyle.Wrap = DefaultBoolean.True;
        column.ColumnType = MVCxGridViewColumnType.TextBox;
        column.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        column.CellStyle.VerticalAlign = System.Web.UI.WebControls.VerticalAlign.Middle;
        column.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        column.Width = Unit.Pixel(190);

    });

    settings.Columns.Add(
    column =>
    {
      column.FieldName = "TRANSP_DESC";
      column.Name = "TRANSP_DESC";
      column.Caption = "Transportation";
      column.CellStyle.Wrap = DefaultBoolean.True;
      column.ColumnType = MVCxGridViewColumnType.TextBox;
      column.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
      column.CellStyle.VerticalAlign = System.Web.UI.WebControls.VerticalAlign.Middle;
      column.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
      column.Width = Unit.Pixel(150);
      column.PropertiesEdit.EncodeHtml = false;
      column.ReadOnly = true;
    });      
      

    settings.Columns.Add(
    column =>
    {
        column.FieldName = "STATUS";
        column.Name = "STATUS";
        column.Caption = "Status";
        column.CellStyle.Wrap = DefaultBoolean.True;
        column.ColumnType = MVCxGridViewColumnType.TextBox;
        column.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        column.CellStyle.VerticalAlign = System.Web.UI.WebControls.VerticalAlign.Middle;
        column.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        column.Width = Unit.Pixel(210);

    });

    settings.Columns.Add(
    column =>
    {
        column.FieldName = "PRINT_FLAG";
        column.Name = "PRINT_FLAG";
        column.Caption = "Print Flag";
        column.CellStyle.Wrap = DefaultBoolean.True;
        column.ColumnType = MVCxGridViewColumnType.SpinEdit;
        column.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        column.CellStyle.VerticalAlign = System.Web.UI.WebControls.VerticalAlign.Middle;
        column.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        column.Width = Unit.Pixel(210);

        SpinEditProperties propertiesSpin = column.PropertiesEdit as SpinEditProperties;
        propertiesSpin.NumberType = SpinEditNumberType.Integer;
        propertiesSpin.DecimalPlaces = 2;
        propertiesSpin.MinValue = 0;
        propertiesSpin.MaxValue = 999999;
    });

    settings.Columns.Add(
    column =>
    {
        column.FieldName = "CHANGED_BY";
        column.Name = "CHANGED_BY";
        column.Caption = "Changed By";
        column.CellStyle.Wrap = DefaultBoolean.False;
        column.Width = Unit.Percentage(0);

    });

    settings.Columns.Add(
    column =>
    {
        column.FieldName = "CHANGED_DT";
        column.Name = "CHANGED_DT";
        column.Caption = "Changed Date";
        column.CellStyle.Wrap = DefaultBoolean.False;
        column.Width = Unit.Percentage(0);

    });


    settings.HtmlDataCellPrepared = (sender, e) =>
    {
      if (e.DataColumn.FieldName == "TRANSP_DESC")
      {
        if (Convert.ToString(e.CellValue).ToLower() != "")
        {
          if (Convert.ToString(e.CellValue).ToLower().Equals("air"))
          {
            e.Cell.BackColor = System.Drawing.Color.Salmon;
            e.Cell.ForeColor = System.Drawing.Color.WhiteSmoke;
          }
          else
          {
            e.Cell.BackColor = System.Drawing.Color.White;
            e.Cell.ForeColor = System.Drawing.Color.Black;
          }
        }
        else
        {
          e.Cell.BackColor = System.Drawing.Color.White;
          e.Cell.ForeColor = System.Drawing.Color.Black;
        }
      }

    };      
          
                 
    }).Bind(Model).GetHtml()